#include "sys_data.h"
#include "led.h"
#include "usart.h"
#include "time.h"

USART_MSG_t usartMsg;
static const uint16_t wCRCTable[] =
    {
        0X0000, 0XC0C1, 0XC181, 0X0140, 0XC301, 0X03C0, 0X0280, 0XC241,
        0XC601, 0X06C0, 0X0780, 0XC741, 0X0500, 0XC5C1, 0XC481, 0X0440,
        0XCC01, 0X0CC0, 0X0D80, 0XCD41, 0X0F00, 0XCFC1, 0XCE81, 0X0E40,
        0X0A00, 0XCAC1, 0XCB81, 0X0B40, 0XC901, 0X09C0, 0X0880, 0XC841,
        0XD801, 0X18C0, 0X1980, 0XD941, 0X1B00, 0XDBC1, 0XDA81, 0X1A40,
        0X1E00, 0XDEC1, 0XDF81, 0X1F40, 0XDD01, 0X1DC0, 0X1C80, 0XDC41,
        0X1400, 0XD4C1, 0XD581, 0X1540, 0XD701, 0X17C0, 0X1680, 0XD641,
        0XD201, 0X12C0, 0X1380, 0XD341, 0X1100, 0XD1C1, 0XD081, 0X1040,
        0XF001, 0X30C0, 0X3180, 0XF141, 0X3300, 0XF3C1, 0XF281, 0X3240,
        0X3600, 0XF6C1, 0XF781, 0X3740, 0XF501, 0X35C0, 0X3480, 0XF441,
        0X3C00, 0XFCC1, 0XFD81, 0X3D40, 0XFF01, 0X3FC0, 0X3E80, 0XFE41,
        0XFA01, 0X3AC0, 0X3B80, 0XFB41, 0X3900, 0XF9C1, 0XF881, 0X3840,
        0X2800, 0XE8C1, 0XE981, 0X2940, 0XEB01, 0X2BC0, 0X2A80, 0XEA41,
        0XEE01, 0X2EC0, 0X2F80, 0XEF41, 0X2D00, 0XEDC1, 0XEC81, 0X2C40,
        0XE401, 0X24C0, 0X2580, 0XE541, 0X2700, 0XE7C1, 0XE681, 0X2640,
        0X2200, 0XE2C1, 0XE381, 0X2340, 0XE101, 0X21C0, 0X2080, 0XE041,
        0XA001, 0X60C0, 0X6180, 0XA141, 0X6300, 0XA3C1, 0XA281, 0X6240,
        0X6600, 0XA6C1, 0XA781, 0X6740, 0XA501, 0X65C0, 0X6480, 0XA441,
        0X6C00, 0XACC1, 0XAD81, 0X6D40, 0XAF01, 0X6FC0, 0X6E80, 0XAE41,
        0XAA01, 0X6AC0, 0X6B80, 0XAB41, 0X6900, 0XA9C1, 0XA881, 0X6840,
        0X7800, 0XB8C1, 0XB981, 0X7940, 0XBB01, 0X7BC0, 0X7A80, 0XBA41,
        0XBE01, 0X7EC0, 0X7F80, 0XBF41, 0X7D00, 0XBDC1, 0XBC81, 0X7C40,
        0XB401, 0X74C0, 0X7580, 0XB541, 0X7700, 0XB7C1, 0XB681, 0X7640,
        0X7200, 0XB2C1, 0XB381, 0X7340, 0XB101, 0X71C0, 0X7080, 0XB041,
        0X5000, 0X90C1, 0X9181, 0X5140, 0X9301, 0X53C0, 0X5280, 0X9241,
        0X9601, 0X56C0, 0X5780, 0X9741, 0X5500, 0X95C1, 0X9481, 0X5440,
        0X9C01, 0X5CC0, 0X5D80, 0X9D41, 0X5F00, 0X9FC1, 0X9E81, 0X5E40,
        0X5A00, 0X9AC1, 0X9B81, 0X5B40, 0X9901, 0X59C0, 0X5880, 0X9841,
        0X8801, 0X48C0, 0X4980, 0X8941, 0X4B00, 0X8BC1, 0X8A81, 0X4A40,
        0X4E00, 0X8EC1, 0X8F81, 0X4F40, 0X8D01, 0X4DC0, 0X4C80, 0X8C41,
        0X4400, 0X84C1, 0X8581, 0X4540, 0X8701, 0X47C0, 0X4680, 0X8641,
        0X8201, 0X42C0, 0X4380, 0X8341, 0X4100, 0X81C1, 0X8081, 0X4040};
// crc校验
uint16_t Checkcrc16(const uint8_t *nData, uint16_t wLength)
{
  uint8_t nTemp;
  uint16_t wCRCWord = 0xFFFF;
  while (wLength--)
  {
    nTemp = *nData++ ^ wCRCWord;
    wCRCWord >>= 8;
    wCRCWord ^= wCRCTable[nTemp];
  }
  return wCRCWord;
}
uint8_t result ;
// 校验码
unsigned char CheckXor(const uint8_t *strData,int len)  
{  
    char checksum = 0;  
    for (int i = 0;i < len;i++)  
    {  
        checksum = checksum ^ strData[i];  
    }  
    return (unsigned char)checksum;  
}  


void call_back()
{
	// 检测发送完成标志位
	if (RESET != USART_GetFlagStatus(USART_232,USART_FLAG_RXNE))
  {
		if (usartMsg.rxIndex < _USART3_RXSIZE - 1){
				usartMsg.rxBuf[usartMsg.rxIndex] = USART_ReceiveData(USART_232);
				usartMsg.rxIndex++;
		}
		else
				USART_ReceiveData(USART_232);
  }
	// 检测空闲标志位
	if ((usartMsg.rxIndex > 0) && RESET != USART_GetFlagStatus(USART_232, USART_FLAG_IDLE))
	{	
			uint8_t i;	
			usartMsg.done = 1;	
			// 清除空闲中断
			i = USART_232->SR; // 先读取SR寄存器
			i = USART_232->DR;	// 再读取DR寄存器	
	}
	else
	{
			uint8_t i;	
			// 清除空闲中断
			i = USART_232->SR; // 先读取SR寄存器
			i = USART_232->DR;	// 再读取DR寄存器	
	}
}

// 发送回馈信息
int sendCmd(uint8_t *data, uint16_t size)
{
	while(usartMsg.txBusy == 1)
	{
		delay_ms(10);
	}
	usartMsg.txBusy = 1;
	memset(usartMsg.rxBuf, 0, _USART3_RXSIZE);
	usartMsg.rxIndex = 0;
	delay_ms(1);
	for (uint16_t i = 0; i < size; i++)
	{
		USART_SendData(USART_232,data[i]);
		while (USART_GetFlagStatus(USART_232, USART_FLAG_TXE) == RESET);
	} 
	while (RESET == USART_GetFlagStatus(USART_232, USART_FLAG_TC));
	usartMsg.done=0;
	usartMsg.txBusy = 0;
	return 1;
}


// 文件更新升级
//uint8_t updata()
//{
//	uint16_t crc;	
//	uint8_t databuf[1024];
//	uint16_t packId = 0x01;
//	uint8_t i = 30,c = 0x63,ack = 0x06,nack = 0x15;
//	// 发送第一个'c'
//	sendCmd(&c,1);
//	//检测 3s 内有无收到数据
//	for(int i = 0; i  < 3000; i++)
//	{
//		delay_ms(1);
//		// 收到数据，跳转到处理数据
//		if(usartMsg.done == 1)
//		{
//			goto __start;
//		}
//	}
//	//3s 内未收到第一包数据，再发送'c'
//	sendCmd(&c,1);

//__start:	
//	// 开始处理数据
//	// 当数据包为EOT(0x04)，表示结束
//	while(usartMsg.done == 1 && usartMsg.rxBuf[0] != 0x04)
//	{
//		// 检测帧头
//		if(usartMsg.rxBuf[0] != 0x02)
//		{
//			sendCmd(&nack,1);
//			goto __start;
//		}
//		// 检测包序列
//		if(usartMsg.rxBuf[1] != packId)
//		{
//			sendCmd(&nack,1);
//			goto __start;
//		}
//		// 检测包号反码
//		if(usartMsg.rxBuf[2] != ~packId)
//		{
//			sendCmd(&nack,1);
//			goto __start;
//		}
//		// 提取数据包
//		for(int i = 0; i < 1024; i++)
//		{
//			databuf[i] = usartMsg.rxBuf[3 + i];
//		}
//		crc = Checkcrc16(databuf, 1024);
//		// 检测数据包的校验码
//		if (((crc & 0x00FF) != usartMsg.rxBuf[1028]) || (((crc & 0xFF00) >> 8) != usartMsg.rxBuf[1027]))
//		{	
//			sendCmd(&nack,1);	
//			goto __start;
//		}
//		// 准备接收下一包数据
//		sendCmd(&ack,1);
//		packId += 1;
//	}
//		// 接收到结束信号，反馈ack
//		sendCmd(&ack,1);
//	if(packId != 0)
//		return 1;
//	else
//		return 2;
//}

void broad_to_host()
{
		int i, j;
		// 数据包大小
		int packIndex = 0;
		result = 2;// 初始化为 2 表示操作失败（硬件故障或其他原因）
		// 反馈信息
		uint8_t txData[8];
		// 校验位验证信息
		uint8_t crc[1 + (4 * usartMsg.rxBuf[4])];
						
		// 判断帧头帧尾
		if(usartMsg.rxBuf[0] != 0xAA || usartMsg.rxBuf[1] != 0xFF || usartMsg.rxBuf[2] != 0x55  || usartMsg.rxBuf[3] != 0xCC|| usartMsg.rxBuf[10 + (4 * (usartMsg.rxBuf[4] - 1))] != 0xDD || usartMsg.rxBuf[11 + (4 * (usartMsg.rxBuf[4] - 1))] != 0xFF)
		{
				result = 0x04;//帧头/帧尾异常
				goto __feedback;
		}
			
		// 判断指令数
		if(usartMsg.rxBuf[4] < 1 || usartMsg.rxBuf[4] > 255)
		{
				result = 5;//帧内容异常（指令值超出范围等）
				goto __feedback;
		}
		
		// 判断校验位	
		// 提取指令数
		crc[0] = usartMsg.rxBuf[4];				
		// 提取指令码、channel、平台号、指令值	
		for(j = 0; j < usartMsg.rxBuf[4] * 4;j += 4)
		{
				crc[1 + j] = usartMsg.rxBuf[5+ j];//指令码
				crc[2 + j] = usartMsg.rxBuf[6+ j];//channel
				crc[3 + j] = usartMsg.rxBuf[7+ j];//平台号
				crc[4 + j] = usartMsg.rxBuf[8+ j];//指令值
				packIndex++;
		}
		if((CheckXor(crc,1 + (4 * usartMsg.rxBuf[4])) != usartMsg.rxBuf[9 + (4 * (usartMsg.rxBuf[4] - 1))]))
		{
				result = 0x03;//校验位异常
				goto __feedback;
		}
		// 数据包判断
		if(usartMsg.rxBuf[4] != packIndex )
		{
				result = 5;//帧内容异常（指令值超出范围等）
				goto __feedback;
		}
		// 执行指令
		for(i = 0; i < usartMsg.rxBuf[4] * 4;i += 4)
		{
			// 判断指令码
			switch (usartMsg.rxBuf[5 + i])
			{
				case 0x01: // LED指令
					result = channel_LED(usartMsg.rxBuf[6 + i], i);
					if(result != 1)	goto __feedback;
						break;
					
				case 0x02: // 12V BAT指令
					result = channel_12VBAT(usartMsg.rxBuf[6 + i], i);
					if(result != 1)	goto __feedback;
						break;
					
				case 0x03: // 5V BAT指令 channel和平台号固定为0x00
					result = channel_5VBAT(usartMsg.rxBuf[8 + i]);
					if(result != 1)goto __feedback;
						break;
					
//				case 0x04: // updata指令
//					if(usartMsg.rxBuf[8] == 1)
//						result = updata();	
//					break;				
				default:
					result = 0x05;//帧内容异常（指令值超出范围等）
					goto __feedback;
			}
		}	
					
__feedback:		
		txData[0] = 0xBB;	// 帧头
		txData[1] = 0xFF;	// 帧头
		txData[2] = 0x55;	// 帧头
		txData[3] = 0xCC;	// 帧头
		txData[4] = result;	// 反馈值		 
		txData[5] = CheckXor(&txData[4], 1);	// 校验位
		txData[6] = 0xEE;	// 帧尾
		txData[7] = 0xFF;	// 帧尾	
		sendCmd(txData,8);
}
